ompi/mca/pml/ob1/pml_ob1_recvreq.h File Reference.TH "ompi/mca/pml/ob1/pml_ob1_recvreq.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/pml/ob1/pml_ob1_recvreq.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'pml_ob1.h'\fP
.br
\fC#include 'pml_ob1_proc.h'\fP
.br
\fC#include 'pml_ob1_rdma.h'\fP
.br
\fC#include 'mca/mpool/base/base.h'\fP
.br
\fC#include 'mca/pml/base/pml_base_recvreq.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PML_OB1_RECV_REQUEST_ALLOC\fP(recvreq, rc)"
.br
.RI "\fIAllocate a recv request from the modules free list. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_RECV_REQUEST_INIT\fP(request,addr,count,datatype,src,tag,comm,persistent)"
.br
.RI "\fIInitialize a receive request with call parameters. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_RECV_REQUEST_RETURN\fP(recvreq)"
.br
.RI "\fIReturn a recv request to the modules free list. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_RECV_REQUEST_START\fP(request)"
.br
.RI "\fIStart an initialized request. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_RECV_REQUEST_MATCHED\fP(request,hdr)"
.br
.ti -1c
.RI "#define \fBMCA_PML_OB1_RECV_REQUEST_UNPACK\fP(request,segments,num_segments,seg_offset,data_offset,bytes_received,bytes_delivered)"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_pml_ob1_recv_request_t \fBmca_pml_ob1_recv_request_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (mca_pml_ob1_recv_request_t)"
.br
.ti -1c
.RI "void \fBmca_pml_ob1_recv_request_match_wild\fP (mca_pml_ob1_recv_request_t *request)"
.br
.RI "\fIAttempt to match the request against the unexpected fragment list for all source ranks w/in the communicator. \fP"
.ti -1c
.RI "void \fBmca_pml_ob1_recv_request_match_specific\fP (mca_pml_ob1_recv_request_t *request)"
.br
.RI "\fIAttempt to match the request against the unexpected fragment list for a specific source rank. \fP"
.ti -1c
.RI "void \fBmca_pml_ob1_recv_request_progress\fP (mca_pml_ob1_recv_request_t *req, struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_segment_t\fP *segments, size_t num_segments)"
.br
.ti -1c
.RI "void \fBmca_pml_ob1_recv_request_matched_probe\fP (mca_pml_ob1_recv_request_t *req, struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_segment_t\fP *segments, size_t num_segments)"
.br
.ti -1c
.RI "void \fBmca_pml_ob1_recv_request_schedule\fP (mca_pml_ob1_recv_request_t *req)"
.br
.ti -1c
.RI "void \fBmca_pml_ob1_recv_request_fin\fP (mca_pml_ob1_recv_request_t *req, size_t rdma_length)"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_PML_OB1_RECV_REQUEST_ALLOC(recvreq, rc)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                               \
   opal_list_item_t* item;                                         \
   rc = OMPI_SUCCESS;                                              \
   OMPI_FREE_LIST_GET(&mca_pml_ob1.recv_requests, item, rc);       \
   recvreq = (mca_pml_ob1_recv_request_t*)item;                    \
} while(0)
.fi
Allocate a recv request from the modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIrc\fP (OUT) OMPI_SUCCESS or error status on failure. 
.RE
.PP
\fBReturns:\fP
.RS 4
Receive request. 
.RE
.PP

.SS "#define MCA_PML_OB1_RECV_REQUEST_INIT(request, addr, count, datatype, src, tag, comm, persistent)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                               \
    (request)->req_rdma_cnt = 0;                                   \
    MCA_PML_BASE_RECV_REQUEST_INIT(                                \
        &(request)->req_recv,                                      \
        addr,                                                      \
        count,                                                     \
        datatype,                                                  \
        src,                                                       \
        tag,                                                       \
        comm,                                                      \
        persistent);                                               \
} while(0)
.fi
Initialize a receive request with call parameters. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Receive request. 
.br
\fIaddr\fP (IN) User buffer. 
.br
\fIcount\fP (IN) Number of elements of indicated datatype. 
.br
\fIdatatype\fP (IN) User defined datatype. 
.br
\fIsrc\fP (IN) Source rank w/in the communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fIpersistent\fP (IN) Is this a ersistent request. 
.RE
.PP

.SS "#define MCA_PML_OB1_RECV_REQUEST_MATCHED(request, hdr)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                 \
    (request)->req_recv.req_base.req_ompi.req_status.MPI_TAG = (hdr)->hdr_tag;       \
    (request)->req_recv.req_base.req_ompi.req_status.MPI_SOURCE = (hdr)->hdr_src;    \
    if((request)->req_recv.req_bytes_packed != 0) {                                  \
        ompi_proc_t *proc =                                                          \
            ompi_comm_peer_lookup(                                                   \
                (request)->req_recv.req_base.req_comm, (hdr)->hdr_src);              \
                                                                                     \
        (request)->req_proc = proc;                                                  \
        ompi_convertor_copy_and_prepare_for_recv( proc->proc_convertor,              \
                                         (request)->req_recv.req_base.req_datatype,  \
                                         (request)->req_recv.req_base.req_count,     \
                                         (request)->req_recv.req_base.req_addr,      \
                                         &(request)->req_recv.req_convertor );       \
    } else {                                                                         \
        (request)->req_proc = NULL;                                                  \
    }                                                                                \
} while (0)
.fi
.SS "#define MCA_PML_OB1_RECV_REQUEST_RETURN(recvreq)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                 \
    size_t r;                                                                        \
    for(r=0; r<recvreq->req_rdma_cnt; r++) {                                         \
        mca_mpool_base_registration_t* btl_reg = recvreq->req_rdma[r].btl_reg;       \
        if(NULL != btl_reg) {                                                        \
            btl_reg->mpool->mpool_release(btl_reg->mpool, btl_reg);                  \
        }                                                                            \
    }                                                                                \
    MCA_PML_BASE_RECV_REQUEST_FINI(&(recvreq)->req_recv);                            \
    OMPI_FREE_LIST_RETURN(&mca_pml_ob1.recv_requests, (opal_list_item_t*)(recvreq)); \
} while(0)
.fi
Return a recv request to the modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Receive request. 
.RE
.PP

.SS "#define MCA_PML_OB1_RECV_REQUEST_START(request)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                              \
    /* init/re-init the request */                                                \
    (request)->req_bytes_received = 0;                                            \
    (request)->req_bytes_delivered = 0;                                           \
    (request)->req_lock = 0;                                                      \
    (request)->req_pipeline_depth = 0;                                            \
    (request)->req_rdma_cnt = 0;                                                  \
    (request)->req_rdma_idx = 0;                                                  \
    (request)->req_recv.req_base.req_pml_complete = false;                        \
    (request)->req_recv.req_base.req_ompi.req_complete = false;                   \
    (request)->req_recv.req_base.req_ompi.req_state = OMPI_REQUEST_ACTIVE;        \
                                                                                  \
    /* always set the req_status.MPI_TAG to ANY_TAG before starting the           \
     * request. This field is used if cancelled to find out if the request        \
     * has been matched or not.                                                   \
     */                                                                           \
    (request)->req_recv.req_base.req_ompi.req_status.MPI_TAG = OMPI_ANY_TAG;      \
    (request)->req_recv.req_base.req_ompi.req_status.MPI_ERROR = OMPI_SUCCESS;    \
    (request)->req_recv.req_base.req_ompi.req_status._cancelled = 0;              \
                                                                                  \
    /* attempt to match posted recv */                                            \
    if((request)->req_recv.req_base.req_peer == OMPI_ANY_SOURCE) {                \
        mca_pml_ob1_recv_request_match_wild(request);                             \
    } else {                                                                      \
        mca_pml_ob1_recv_request_match_specific(request);                         \
    }                                                                             \
} while (0)
.fi
Start an initialized request. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP Receive request. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCESS or error status on failure. 
.RE
.PP

.SH "Function Documentation"
.PP 
.SS "void mca_pml_ob1_recv_request_match_specific (mca_pml_ob1_recv_request_t * request)"
.PP
Attempt to match the request against the unexpected fragment list for a specific source rank. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Request to match. 
.RE
.PP

.SS "void mca_pml_ob1_recv_request_match_wild (mca_pml_ob1_recv_request_t * request)"
.PP
Attempt to match the request against the unexpected fragment list for all source ranks w/in the communicator. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Request to match. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
